clang 8.0.0

Public Types | Public Member Functions | Public Attributes | List of all members
clang::CFG::BuildOptions Class Reference

`#include "clang/Analysis/CFG.h"`

Collaboration diagram for clang::CFG::BuildOptions:
[legend]

## Public Types
using | ForcedBlkExprs = llvm::DenseMap< const Stmt *, const CFGBlock * >

## Public Member Functions
| BuildOptions ()=default
bool | alwaysAdd (const Stmt *stmt) const
BuildOptions & | setAlwaysAdd (Stmt::StmtClass stmtClass, bool val=true)
BuildOptions & | setAllAlwaysAdd ()

## Public Attributes
ForcedBlkExprs ** | forcedBlkExprs = nullptr
CFGCallback * | Observer = nullptr
bool | PruneTriviallyFalseEdges = true
bool | AddEHEdges = false
bool | AddInitializers = false
bool | AddImplicitDtors = false
bool | AddLifetime = false
bool | AddLoopExit = false
bool | AddTemporaryDtors = false
bool | AddScopes = false
bool | AddStaticInitBranches = false
bool | AddCXXNewAllocator = false
bool | AddCXXDefaultInitExprInCtors = false
bool | AddRichCXXConstructors = false
bool | MarkElidedCXXConstructors = false

## Detailed Description

Definition at line 1009 of file CFG.h.

## Member Typedef Documentation

## ◆ ForcedBlkExprs

using clang::CFG::BuildOptions::ForcedBlkExprs = llvm::DenseMap<const Stmt *, const CFGBlock *>

Definition at line 1013 of file CFG.h.

## Constructor & Destructor Documentation

## ◆ BuildOptions()

clang::CFG::BuildOptions::BuildOptions | ( |  | ) |
| default

## Member Function Documentation

## ◆ alwaysAdd()

bool clang::CFG::BuildOptions::alwaysAdd | ( | const Stmt * | stmt | ) | const
| inline

Definition at line 1033 of file CFG.h.

References clang::Stmt::getStmtClass().

## ◆ setAllAlwaysAdd()

BuildOptions& clang::CFG::BuildOptions::setAllAlwaysAdd | ( |  | ) |
| inline

Definition at line 1042 of file CFG.h.

References clang::C.

Referenced by clang::sema::AnalysisBasedWarnings::IssueWarnings().

## ◆ setAlwaysAdd()

BuildOptions& clang::CFG::BuildOptions::setAlwaysAdd | ( | Stmt::StmtClass | stmtClass,
|  | bool | val = `true`
| ) |  |
| inline

Definition at line 1037 of file CFG.h.

Referenced by clang::sema::AnalysisBasedWarnings::IssueWarnings().

## Member Data Documentation

## ◆ AddCXXDefaultInitExprInCtors

bool clang::CFG::BuildOptions::AddCXXDefaultInitExprInCtors = false

Definition at line 1027 of file CFG.h.

Referenced by clang::sema::AnalysisBasedWarnings::IssueWarnings().

## ◆ AddCXXNewAllocator

bool clang::CFG::BuildOptions::AddCXXNewAllocator = false

Definition at line 1026 of file CFG.h.

Referenced by clang::AnalysisDeclContextManager::AnalysisDeclContextManager(), and clang::sema::AnalysisBasedWarnings::IssueWarnings().

## ◆ AddEHEdges

bool clang::CFG::BuildOptions::AddEHEdges = false

Definition at line 1018 of file CFG.h.

Referenced by clang::reachable_code::FindUnreachableCode(), clang::AnalysisDeclContext::getAddEHEdges(), and clang::sema::AnalysisBasedWarnings::IssueWarnings().

## ◆ AddImplicitDtors

bool clang::CFG::BuildOptions::AddImplicitDtors = false

Definition at line 1020 of file CFG.h.

Referenced by clang::AnalysisDeclContextManager::AnalysisDeclContextManager(), clang::ento::ExprEngine::bindReturnValue(), clang::AnalysisDeclContext::getAddImplicitDtors(), and clang::sema::AnalysisBasedWarnings::IssueWarnings().

## ◆ AddInitializers

bool clang::CFG::BuildOptions::AddInitializers = false

Definition at line 1019 of file CFG.h.

Referenced by clang::AnalysisDeclContextManager::AnalysisDeclContextManager(), clang::ento::ExprEngine::bindReturnValue(), clang::AnalysisDeclContext::getAddInitializers(), and clang::sema::AnalysisBasedWarnings::IssueWarnings().

## ◆ AddLifetime

bool clang::CFG::BuildOptions::AddLifetime = false

Definition at line 1021 of file CFG.h.

Referenced by clang::AnalysisDeclContextManager::AnalysisDeclContextManager().

## ◆ AddLoopExit

bool clang::CFG::BuildOptions::AddLoopExit = false

Definition at line 1022 of file CFG.h.

Referenced by clang::AnalysisDeclContextManager::AnalysisDeclContextManager().

## ◆ AddRichCXXConstructors

bool clang::CFG::BuildOptions::AddRichCXXConstructors = false

Definition at line 1028 of file CFG.h.

Referenced by clang::AnalysisDeclContextManager::AnalysisDeclContextManager().

## ◆ AddScopes

bool clang::CFG::BuildOptions::AddScopes = false

Definition at line 1024 of file CFG.h.

Referenced by clang::AnalysisDeclContextManager::AnalysisDeclContextManager().

## ◆ AddStaticInitBranches

bool clang::CFG::BuildOptions::AddStaticInitBranches = false

Definition at line 1025 of file CFG.h.

Referenced by clang::AnalysisDeclContextManager::AnalysisDeclContextManager().

## ◆ AddTemporaryDtors

bool clang::CFG::BuildOptions::AddTemporaryDtors = false

Definition at line 1023 of file CFG.h.

Referenced by clang::AnalysisDeclContextManager::AnalysisDeclContextManager(), clang::sema::AnalysisBasedWarnings::IssueWarnings(), and clang::ento::ExprEngine::VisitCXXConstructExpr().

## ◆ forcedBlkExprs

ForcedBlkExprs** clang::CFG::BuildOptions::forcedBlkExprs = nullptr

Definition at line 1015 of file CFG.h.

Referenced by clang::AnalysisDeclContext::AnalysisDeclContext().

## ◆ MarkElidedCXXConstructors

bool clang::CFG::BuildOptions::MarkElidedCXXConstructors = false

Definition at line 1029 of file CFG.h.

Referenced by clang::AnalysisDeclContextManager::AnalysisDeclContextManager().

## ◆ Observer

CFGCallback* clang::CFG::BuildOptions::Observer = nullptr

Definition at line 1016 of file CFG.h.

Referenced by clang::AnalysisDeclContext::getCFG(), clang::AnalysisDeclContext::getUnoptimizedCFG(), and clang::sema::AnalysisBasedWarnings::IssueWarnings().

## ◆ PruneTriviallyFalseEdges

bool clang::CFG::BuildOptions::PruneTriviallyFalseEdges = true

Definition at line 1017 of file CFG.h.

Referenced by clang::AnalysisDeclContextManager::AnalysisDeclContextManager(), clang::AnalysisDeclContext::getCFG(), clang::AnalysisDeclContext::getUnoptimizedCFG(), clang::AnalysisDeclContext::getUseUnoptimizedCFG(), clang::AnalysisDeclContextManager::getUseUnoptimizedCFG(), and clang::sema::AnalysisBasedWarnings::IssueWarnings().

The documentation for this class was generated from the following file:

- include/clang/Analysis/CFG.h